class Particle {  // Klasse der Partikel wird definiert durch Vektoren der Position, Geschwindigkeit und Beschleunigung
  PVector pos = new PVector(random(width), random(height));
  PVector vel = new PVector(0, 0);
  PVector acc = new PVector(0, 0);
  float maxSpeed = 4;


  PVector prevPos = pos.copy();

  public void update() {    // die unten definierten Funktionen werden auf die Vektoren der Partikel angewendet, um diese in Bewegung zu setzen
    vel.add(acc);
    vel.limit(maxSpeed);
    pos.add(vel);
    acc.mult(0);
  }

  public void follow(PVector[] vectors) {    // Funktion des Vektor-Arrays, der jeder x- und y-Position einen Platz in der Vektorreihe zuordnet und durch Verschieben aktualisiert
    int x = floor(pos.x / scl);
    int y = floor(pos.y / scl);
    int index = (x-1) + ((y-1) * cols);

    index = index - 1;
    if (index > vectors.length || index < 0) {
      index = vectors.length - 1;
    }
    
    PVector force = vectors[index];
    applyForce(force);
  }

  void applyForce(PVector force) {    // Funktionsdefinition, die Partikel beschleunigt
    acc.add(force);
  }


  float speedr = 1.5;    // Geschwindigkeit mit der sich R, G und B-Farbwerte durch Addition verändern
  float speedg = 1;
  float speedb = 0.5;

  float r = 0;    // Start-Farbwerte
  float g = 50;
  float b = 100;

  public void show() {    // Funktion, die den Farbwechsel der Partikel gewährleistet
    stroke(r, g, b);
    strokeWeight(7);
    point(pos.x, pos.y);

    r= r + speedr;
    g= g + speedg;
    b= b + speedb;

    r=constrain(r, 0, 255);    // Werte werden zwischen 0 und 255 gehalten
    g=constrain(g, 0, 255);
    b=constrain(b, 0, 255);

    if (r==255 || r==0) {    // Endlosschleife des Farbwechsels
      speedr= speedr * -1;
    }
    if (g==255 || g==0) {
      speedg= speedg * -1;
    }
    if (b==255 || b==0) {
      speedb= speedb * -1;
    }
  }

  public void updatePrev() {    // x- und y-Position der Partikel wird upgedated
    prevPos.x = pos.x;
    prevPos.y = pos.y;
  }

  public void edges() {    // Bei Übertreten der Partikel der Kanten werden diese wieder auf Position null gestezt und bleiben somit endlos im Bild
    if (pos.x > width) {
      pos.x = 0;
      updatePrev();
    }
    if (pos.x < 0) {
      pos.x = width;
      updatePrev();
    }

    if (pos.y > height) {
      pos.y = 0;
      updatePrev();
    }
    if (pos.y < 0) {
      pos.y = height;
      updatePrev();
    }
  }
}
